<?
//ELEMETOS RANDOMICOS - Para ilustrar este cdigo apresenta uma funo que ir gerar frases aleatoriamente

// Array com as frases que iro ser exibidas aleatoriamente
$frases = array(
  "Perder o entusiasmo  criar rugas na alma.",
  "Pense grande a respeito de si mesmo, e o mundo achar que voc  aquilo que pensa.",
  "O segredo de qualquer conquista  a coisa mais simples do mundo: saber o que fazer com ela.",
  "Ou no comece ou, tendo comeado, no desista.",
  "Viso  a capacidade de enxergar alm do que os olhos so capazes."
);

/*
microtime -  Retorna um timestamp Unix com microsegundos
Descrio:
mixed microtime ( [bool get_as_float] )

A microtime() retorna o timestamp atual com microsegundos. Esta funo est apenas disponvel em sistemas operacionais que suportam o chamda do sistema gettimeofday().
Quando chamada sem o argumento opcional, esta funo retorna a string "msec sec" onde sec  o a hora atual medida em segundos desde a era UNIX (0:00:00 January 1, 1970 GMT), e msec  a parte em microsegundos. Ambas pores de string so retornadas em segundos.
Quando get_as_float  dado, e avalia para TRUE, microtime() retornar um tipo float.
*/

//srand - Semeia o gerador de nmeros aletrios
/*
shuffle - Mistura os elementos de um array
void shuffle ( array array)
Essa funo mistura de forma aleatria os elementos de um array. Voc deve usar essa funo em conjunto com srand(). 
*/

// ordenar o array randomicamente
srand ((float)microtime()*1000000);
shuffle ($frases);

// mostrar o 1o. elemento do array, que ser randmico
echo "Frase do Dia: " .$frases[0];

/*
rand - Gera um nmero aleatrio
Descrio
int rand ( [int min, int max])
Se chamado sem os parmetros opcionais min e max, rand() retornar um pseudo valor randmico entre 0 e RAND_MAX. Se voc precisa de um nmero aleatrio entre 5 e 15 (inclusive), por exemplo, utilize rand (5, 15).
Nota: - Em algumas plataformas (como o Windows) RAND_MAX  somente 32768. Se voc precisa de um nmero maior que 32768, considere utilizar mt_rand(). 
      - A partir do PHP 4.2.0, no  mais necessrio semear o gerador de nmeros aleatrios com srand() ou mt_srand() pois isso  feito automaticamente. 
	  - Em verses anteriores a 3.0.7, o significado do parmetro max era range. Assim, para obter os mesmos resultados do exemplo acima, voc precisaria utilizar rand (5, 11) para obter um nmero aleatrio entre 5 e 15. 

*/
echo "<br><br><br>Usando o RAND<br>";
$resp = rand(0,10);
echo $resp;
//echo count($frases);
/*
getrandmax - Retorna o maior valor aletrio possvel
Descrio
int getrandmax ( void )
Retorna o valor mximo que pode ser gerado em uma chamada a funo rand(). 
*/
echo "<br><br><br>Usando o GETRANDMAX<br>";
$max = getrandmax();
echo $max;
//ex: 
//echo rand(0,getrandmax());

/*
mt_rand - Gerador melhorado de nmeros aleatrios
Descrio
int mt_rand ( [int min, int max])

Muitos geradores de nmeros aleatrios das libcs antigas so duvidosos ou com caractersticas duvidosas e lentos. 
Por default, o PHP utiliza o gerador de nmeros aleatrios da libc para a funo rand(). A funo mt_rand()  um bom substituto para a primeira. 
Ela utiliza um gerador de nmeros aleatrios com caractersticas conhecidas, o Mersenne Twister, que produzir nmeros randmicos que podem ser utilizados como sementes em alguns tipos de criptografia e 
 em mdia quatro vezes mais rpido do que o fornecido pela libc.
Se chamada sem os argumentos opcionais min e max, mt_rand() retorna um pseudo nmero aletrio enrte 0 e RAND_MAX. 
Se voc precisa de um nmero randmico entre 5 e 15 (inclusive), por exemplo, utilize mt_rand (5, 15).
Nota:  - A partir do PHP 4.2.0, no  mais necessrio semear o gerador de nmeros aleatrios com srand() ou mt_srand() pois isso  feito automaticamente. 
	   - Em verses anteriores a 3.0.7, o significado do parmetro max era range. Assim, para obter os mesmos resultados do exemplo acima, voc precisaria utilizar rand (5, 11) para obter um nmero aleatrio 
	   entre 5 e 15. 
*/
echo "<br><br><br>Usando o MT_RAND<br>";
$resp1 = mt_rand(0,15);
echo $resp1;

// EXERCICIOS: Recrie uma funo similar a apresentada em no exemplo acima, mas sem utilizar a funo shuffle():

?>