<?
/*
Range

array range(int minimo, int maximo);

Essa funo cria um array onde os elementos so inteiros, pertencentes ao intervalo especificado na funo. 
Caso o primeiro parmetro seja maior que o segundo, o valor retornado ser vazio (false).
*/

// array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ,11, 12) 
foreach(range(0, 12) as $numero) { 
echo $numero;
}
echo "<br><br><br><br>";
// Utilizao da seqncia de caracteres introduzidos no 4.1.0 
// array('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i'); 
foreach(range('a', 'i') as $letra) {
echo $letra;
}
echo "<br><br><br><br>";
// array('c', 'b', 'a'); 
foreach(range('c', 'a') as $letra) {
echo $letra;
}
echo "<br><br><br><br>";


/* 
Funes de "navegao"

As variveis do tipo array tm um ponteiro interno que indica qual o prximo elemento ser acessado, no caso de no ser especificado um ndice. 
As funes listadas abaixo modificam esse ponteiro, fazendo com que seja possvel percorrer o array para verificar suas chaves e elementos.

Reset
mixed reset(array arr);
Seta o ponteiro para o 1 elemento do array, retornando o contedo do elemento.
*/
$array = array('primero', 'segundo', 'terceiro', 'quarto'); 
//o ponteiro est sobre o primeiro elemento 
echo current($array)."<br>\n"; // "primeiro"
// pula dois elementos 
next($array); 
next($array); 
echo current($array)."<br>\n"; // "terceiro" 
// reinicia o ponteiro, comea novamente o primeiro elemento 
reset($array); 
echo current($array)."<br>\n"; // "primeiro" 

echo "<br><br><br><br>";
/*
mixed end(array arr);
Seta o ponteiro interno para o ltimo elemento do array, retornando o contedo desse elemento.
*/
$carros = array('corsa', 'fox', 'parati');
echo end($carros); // parati

echo "<br><br><br><br>";

/*
No aconselho o uso dessa funo para saber se um elemento  o ltimo do array, pois ela pode retornar false tanto no final do array como no caso de haver um elemento vazio.
Prev
mixed prev(array arr);
Seta o ponteiro para o elemento anterior do array, retornando o contedo desse elemento. Funciona de maneira inversa a next.
*/
$transportes = array('moto', 'bicicleta', 'carrro', 'avio'); 
$mode = current($transportes); // $mode = 'moto'; 
$mode = next($transportes); // $mode = 'bicicleta'; 
$mode = next($transportes); // $mode = 'carrro'; 
$mode = prev($transportes); // $mode = 'bicicleta'; 
$mode = end($transportes); // $mode = 'avio'; 

/*
Pos
mixed pos(array arr);
O valor retornado  o contedo do elemento atual do array, indicado pelo ponteiro.
*/
$transportes = array('moto', 'bicicleta', 'carrro', 'avio'); 
$mode = current($transportes); // $mode = 'moto'; 
$mode = next($transportes); // $mode = 'bicicleta'; 
$mode = next($transportes); // $mode = 'carro'; 
pos ($transportes); // retorna "carro";
$mode = prev($transportes); // $mode = 'bicicleta'; 
$mode = end($transportes); // $mode = 'avio'; 

/*
Key
mixed key(array arr);
O seu funcionamento  parecido com o da funo pos, mas ao invs de retornar o elemento atual indicado pelo ponteiro do array, retorna seu ndice.
*/
$array = array( 
'fruta1' => 'ma', 
'fruta2' => 'laranja', 
'fruta3' => 'uva', 
'fruta4' => 'ma', 
'fruta5' => 'ma'); 

// este ciclo exibir toda a chave do array associativo 
// onde o valor  igual a "ma"
 
while ($fruta_nome = current($array))
{ 
	if ($fruta_nome == 'ma') 
	{ 
	echo key($array).'<br>'; 
	}	 
next($array); 
} 
echo "<br><br><br><br>";
?>

